var gMyScrollArea, gMyScrollBar;
var refUrl = "http://www.cnrtl.fr/";
var choix_dico = "definition";
var choix_dico_name = "Dictionnaire";
var growboxInset;
var liens = new Array();
var variantes;
var collapsed = true;
var collapsed_x = 318;
var collapsed_y = 62;
var min_x = 370;
var min_y = 280;
var lancerRecherche = false;
function load() {
    setup();
}
function remove() {
}
function hide() {
}
function show() {
	check_update();
}
function sync() {
}
function $(id) {
	return document.getElementById(id);
}

function trim(str) {
    return str.replace(/^\s+/, "").replace(/\s+$/, "");
}

function ltrim(str) {
    return str.replace(/^\s+/, "");
}

function transfert(str) {
	/*$("idSelectDictionnaire-label").innerHTML="hidden";*/
	$('mot').value = str;
	recherche();
}

function selectDictionnaire(){
	quel_dico = $("idSelectDictionnaire").options.selectedIndex;

	les_dicos_name = new Array("Dictionnaire", "Étymologie", "Synonymie", "Antonymie", "Morphologie", "Concordance");
	les_dicos_values = new Array("definition","etymologie","synonymie","antonymie","morphologie","concordance");

	choix_dico_name = les_dicos_name[quel_dico];
	choix_dico = les_dicos_values[quel_dico];
	$('idSelectDictionnaire-label').innerText = choix_dico_name;
	recherche();
}

function reglerLesLiens() {
  // gérer le petit tableau html qui contient les éventuels homonymes mot.
  tables = $("definitionDiv").getElementsByTagName("table");
  rangees = tables[2].getElementsByTagName("tr");
  if(rangees[1] != undefined && rangees[0].hasAttribute("onclick")){ // s'il y a plus d'une possibilité
	  variantes = tables[2].innerHTML;
	  variantes = variantes.replace(/\/definition\//g,"");
	  variantes = variantes.replace(/\/etymologie\//g,"");
	  variantes = variantes.replace(/\/morphologie\//g,"");
	  variantes = variantes.replace(/\/synonymie\//g,"");
	  variantes = variantes.replace(/\/antonymie\//g,"");
	  variantes = variantes.replace(/\/concordance\//g,"");
	  variantes = variantes.replace(/\/\//g,"/");
	  variantes = variantes.replace(/return sendRequest\(5,/g,"recherche(");
  }else{
	  variantes = "";
  }
  $("definitionDiv").innerHTML = variantes+$("contentbox").innerHTML;
  
  // Permettre de cliquer sur un des synonymes ou antonymes.
  liens = $("definitionDiv").getElementsByTagName("a");
  for (var i=0; i < liens.length; i++) {
	var motPropose = liens[i].innerHTML;
	liens[i].setAttribute("onclick", "transfert('"+motPropose+"');return false;");
  }
  
  // remplacer les attributs src des img (y ajouter http: //www.cnrtl.fr)
  images = $("definitionDiv").getElementsByTagName("img");
  for (var t=0; t < images.length; t++) {
	var src_img = images[t].getAttribute("src");
	images[t].setAttribute("src", "http://www.cnrtl.fr"+src_img);
  };
  
  parag = $("definitionDiv").getElementsByTagName("p");
  if(parag[0]){
	parag[0].removeAttribute("style");
  }
  if(parag[1]){
	parag[1].removeAttribute("style");
  }
}

function setup() {
    gMyScrollBar = new AppleVerticalScrollbar($("scrollBar"));
    gMyScrollArea = new AppleScrollArea($("definitionDiv"));
    gMyScrollArea.addScrollbar(gMyScrollBar);
	gMyScrollArea.scrollsVertically=true;
	$("scrollBar").style.display = "none";
	$('idSelectDictionnaire-label').innerText = choix_dico_name;
}

function showBack(event) {
    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }
    $("front").style.display = "none";
    $("back").style.display = "block";
    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

function showFront(event) {
    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }
    $("front").style.display="block";
    $("back").style.display="none";
    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

function searchFieldKeyPressed(evt) { // quand on appuye sur entrée ou retour
	var keyCode = evt.keyCode;
	if (13 == keyCode || 3 == keyCode) { // return or enter key
		lancerRecherche = true;
	}
}

function doRefRequest() {
	if(lancerRecherche){
		if($("front").className == "small"){
			anime(event);
		}else if(ltrim($("mot").value) == ""){
			recherche();
		}else{
			setTimeout("recherche()",500);
		}
	}
}

function GetElementsWithClassName(elementName,wichClassName) {
    var allElements = document.getElementsByTagName(elementName);
    var elemColl = new Array();
    for (var i = 0; i< allElements.length; i++) {
		if (allElements[i].className == wichClassName) {
			elemColl[elemColl.length] = allElements[i];
		}
    }
    return elemColl;
}

function mettreLienSurLeMot(lienUrl){
	var leMot = GetElementsWithClassName("span","tlf_cmot");
	if (leMot[0]){
		leMot[0].setAttribute("onclick", "openlink('"+lienUrl+"');return false;");
	}
}

function recherche(homonymie){
	if (homonymie == undefined){
		var searchValue = ltrim($("mot").value);
	}else{
		var searchValue = homonymie;
	}
	var lienUrl = refUrl+choix_dico+"/"+searchValue;
	if(searchValue != ""){
		var req = new XMLHttpRequest();
		req.onreadystatechange = function(){
			if(req.readyState == 4){
				if (req.status == 200){
					var definition = req.responseText.replace(/(^\s*)|(\s*$)/g,"");
					$("definitionDiv").innerHTML = definition;
					reglerLesLiens();
					mettreLienSurLeMot(lienUrl);
					adapterBarresDePertinence();
					gMyScrollArea.refresh();
					gMyScrollArea.verticalScrollTo(0);
				} else {
					$("definitionDiv").setAttribute("href","");
					$("definitionDiv").innerHTML = "<p>Le dictionnaire n'a pas pu se connecter à internet.</p>";			
				}
			}
		}
		req.open("GET", lienUrl, true);
		req.send(null);
	} else {
		if($("front").className == "large"){
			anime(event);
		}
		$("definitionDiv").innerHTML = "";
		gMyScrollArea.refresh();
	}
}

function openlink(adresse){
	if (window.widget) {
		widget.openURL(adresse);
	}
}


// début du code resize redimentionnement
function mouseDown(event) {
 
    document.addEventListener("mousemove", mouseMove, true);
    document.addEventListener("mouseup", mouseUp, true);
 
    growboxInset = {x:(window.innerWidth - event.x), y:(window.innerHeight - event.y)};
	
    event.stopPropagation();
    event.preventDefault();

}
 
function mouseMove(event) {
 
    var x = event.x + growboxInset.x;
    var y = event.y + growboxInset.y;
 
    $("resize").style.top = (y-12);
	if(x <= min_x){
		x = min_x;
	}
	if(y <= min_y){
		y = min_y;
	}
	window.resizeTo(x,y);
    event.stopPropagation();
    event.preventDefault();
	gMyScrollArea.refresh();
	adapterBarresDePertinence();
}

function mouseUp(event) {
    document.removeEventListener("mousemove", mouseMove, true);
    document.removeEventListener("mouseup", mouseUp, true);
 
    event.stopPropagation();
    event.preventDefault();
	//alert(window.innerWidth);
	widget.setPreferenceForKey(window.innerWidth,"windowWidth");
	widget.setPreferenceForKey(window.innerHeight,"windowHeight");
}
// fin du code resize


function anime(evt) { // agrandissement réduction redimentionnement
	if ($("front").className == "resizing") {
		return;
	}
	var isSmall = ("small" == $("front").className);
	$("front").className = "resizing";

	var smallRect = new AppleRect(0, 0, collapsed_x, collapsed_y);
	if(window.innerHeight > collapsed_y || window.innerWidth > collapsed_x){
		var largeRect = new AppleRect(0, 0, window.innerWidth, window.innerHeight);
	}else{
		var largeur = widget.preferenceForKey("windowWidth");
		var hauteur = widget.preferenceForKey("windowHeight");
		
		if (largeur && largeur > 0 && hauteur && hauteur > 0){
			var largeRect = new AppleRect(0, 0, largeur, hauteur);
		}else{
			var largeRect = new AppleRect(0, 0, min_x, min_y);
		}
		
	}

	var startingRect = (isSmall) ? smallRect : largeRect;
	var finishingRect  = (isSmall) ? largeRect : smallRect;
	
	var currentAnimator = new AppleAnimator(500, 10);
	
	var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectHandler );
	function rectHandler( currentRectAnimation, currentRect, startingRect, finishingRect ){
		window.resizeTo(currentRect.right,currentRect.bottom);
		//$("front").style.width = currentRect.right+"px";
		//$("front").style.height = currentRect.bottom+"px";
	}
	
	currentAnimator.addAnimation(currentRectAnimation);
	currentAnimator.oncomplete = function() {
		resizeCompleteHandler(isSmall);
	}
	currentAnimator.start();
}

function resizeCompleteHandler(wasSmall) {
    $("front").className = (wasSmall) ? "large" : "small";
	if($("front").className == "large"){
		$("scrollBar").style.display = "block";
		recherche();
		gMyScrollArea.refresh();
	}else{
		$("scrollBar").style.display = "none";
		lancerRecherche = false;
	}
}

function adapterBarresDePertinence(){
	// var table = GetElementsWithClassName("table","light_frame");
	var tables = document.getElementsByTagName("table");
	for (var i = 0; i < tables.length; i++) {
		if (tables[i].getAttribute("class") == "light_frame"){
			var table = tables[i];
		}else{
			var table = undefined;
		}
	}
	if (table){
		var images = table.getElementsByTagName("img");
		for (var r = 0; r < images.length; r = r+2) { 
			var largeur1 = images[r].getAttribute("width");
			var largeur2 = images[r+1].getAttribute("width");
			var newLargeur1 = ((window.innerWidth-225)/450)*largeur1;
			var newLargeur2 = ((window.innerWidth-225)/450)*largeur2;
			images[r].style.width = newLargeur1+"px";
			images[r+1].style.width = newLargeur2+"px";
		}
	}
}

function check_update(){
	var upd = new XMLHttpRequest();
	upd.onreadystatechange = function(){
		if(upd.readyState == 4){
			if (upd.status == 200){
				$("updateAvailable").innerHTML = upd.responseText;
			}
		}
	}
	upd.open("GET", "http://www.dicowidget.net/dicoUpdate.html", true);
	upd.send(null);
}